package sun.security.tools.policytool;

import sun.security.provider.PolicyParser;
import java.text.MessageFormat;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

class NewPolicyPrinOKButtonListener implements ActionListener
{
    private PolicyTool tool;
    private ToolWindow tw;
    private ToolDialog listDialog;
    private ToolDialog infoDialog;
    private boolean edit;
    
    NewPolicyPrinOKButtonListener(PolicyTool tool, ToolWindow tw, ToolDialog listDialog, ToolDialog infoDialog, boolean edit) {
        this.tool = tool;
        this.tw = tw;
        this.listDialog = listDialog;
        this.infoDialog = infoDialog;
        this.edit = edit;
    }
    
    @Override
    public void actionPerformed(ActionEvent actionEvent) {
        try {
            PolicyParser.PrincipalEntry prinFromDialog = this.infoDialog.getPrinFromDialog();
            if (prinFromDialog != null) {
                try {
                    this.tool.verifyPrincipal(prinFromDialog.getPrincipalClass(), prinFromDialog.getPrincipalName());
                }
                catch (ClassNotFoundException ex) {
                    MessageFormat messageFormat = new MessageFormat(PolicyTool.getMessage("Warning.Class.not.found.class"));
                    Object[] array = { prinFromDialog.getPrincipalClass() };
                    this.tool.warnings.addElement(messageFormat.format(array));
                    this.tw.displayStatusDialog(this.infoDialog, messageFormat.format(array));
                }
                TaggedList list = (TaggedList)this.listDialog.getComponent(6);
                String principalEntryToUserFriendlyString = ToolDialog.PrincipalEntryToUserFriendlyString(prinFromDialog);
                if (this.edit) {
                    list.replaceTaggedItem(principalEntryToUserFriendlyString, prinFromDialog, list.getSelectedIndex());
                }
                else {
                    list.addTaggedItem(principalEntryToUserFriendlyString, prinFromDialog);
                }
            }
            this.infoDialog.dispose();
        }
        catch (Exception ex2) {
            this.tw.displayErrorDialog(this.infoDialog, ex2);
        }
    }
}
